<template>
  <div>
    <h1>MAP COMPONENT</h1>
    <button ref="btnStartTracking">Start</button>
    <h3>Tracking: {{ trackingPosition }}</h3>
    <button ref="btnStopTracking">Stop</button>
    <button @click="fntTest">OK</button>
    <v-btn color="red lighten-2" dark ref="btnStartTracking">
      Grabar
    </v-btn>
    <v-btn color="red lighten-2" dark ref="btnStopTracking">
      Parar
    </v-btn>
    <v-btn color="red lighten-2" dark @click="dialogHistory = true">
      Click Me
    </v-btn>
    <p>
      {{ geojson }}
      {{ centerPosition }}
    </p>
    <div id="map-cont">
      <div id="map"></div>
    </div>

    <v-dialog v-model="dialogHistory" width="500">
      <v-card>
        <v-card-title class="text-h5 grey lighten-2">
          Historial de rutas
        </v-card-title>
        <v-card-text>
          Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do
          eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad
          minim veniam, quis nostrud exercitation ullamco laboris nisi ut
          aliquip ex ea commodo consequat. Duis aute irure dolor in
          reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla
          pariatur. Excepteur sint occaecat cupidatat non proident, sunt in
          culpa qui officia deserunt mollit anim id est laborum.
        </v-card-text>

        <v-divider></v-divider>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="dialogHistory = false">
            I accept
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import mapboxgl from "mapbox-gl";

export default {
  name: "MapCustom",
  data: () => ({
    dialogHistory: false,
    accessToken:
      "pk.eyJ1IjoiZGllZ29leHBhbnNpb24iLCJhIjoiY2w4dnF2bngwMGdobDN2bzhibHl5YzlwbyJ9.OuGTaxTKzyag57iMZAQd-A",
    intervalS: null,
    trackingPosition: false,
    watchID: null,
    mapObject: null,
    centerPosition: {
      lat: 10.762622,
      lng: 106.660172,
    },
    zoom: 16,
    positions: [],
    geojson: {
      type: "Feature",
      properties: {},
      geometry: {
        type: "LineString",
        coordinates: [
          // [-75.29834, 2.9498336],
          // [-75.29874, 2.9498376]
        ],
      },
    },
  }),
  props: {
    msg: String,
  },
  mounted() {
    navigator.geolocation.getCurrentPosition(
      this.initMap,
      this.failurePosition,
      {
        enableHighAccuracy: true,
      }
    );
  },
  methods: {
    fntTest() {
      console.log("TTT");
    },
    initMap(position) {
      let self = this;
      self.centerPosition = {
        lat: position.coords.latitude,
        lng: position.coords.longitude,
      };
      mapboxgl.accessToken = self.accessToken;
      const map = new mapboxgl.Map({
        container: "map", // container ID
        style: "mapbox://styles/mapbox/streets-v11", // style URL
        center: [position.coords.longitude, position.coords.latitude], // [lng, lat]
        zoom: 16, // starting zoom
      });
      // Marcador posicion actual
      let currentPositionMarker = new mapboxgl.Marker()
        .setLngLat([position.coords.longitude, position.coords.latitude])
        .addTo(map);
      let geojson = self.geojson;
      // let geojson = {
      //   type: "Feature",
      //   properties: {},
      //   geometry: {
      //     type: "LineString",
      //     coordinates: [
      //       // [-75.29834, 2.9498336],
      //       // [-75.29874, 2.9498376]
      //     ],
      //   },
      // };
      map.on("load", () => {
        map.addSource("route", {
          type: "geojson",
          data: geojson,
        });
        map.addLayer({
          id: "route",
          type: "line",
          source: "route",
          layout: {
            "line-join": "round",
            "line-cap": "round",
          },
          paint: {
            "line-color": "red",
            "line-width": 5,
          },
        });

        let interval = null;

        self.$refs.btnStartTracking.addEventListener("click", function () {
          self.trackingPosition = true;
          interval = setInterval(async () => {
            navigator.geolocation.getCurrentPosition(
              (position) => {
                setGeoJson(position);
                setCurrentPosition(position);
              },
              self.failurePosition,
              {
                enableHighAccuracy: true,
              }
            );
          }, 2000);
        });

        self.$refs.btnStopTracking.addEventListener("click", function () {
          self.trackingPosition = false;
          window.clearInterval(interval);
          geojson.geometry.coordinates = [];
          map.getSource("route").setData(geojson);
        });

        const setGeoJson = (position) => {
          let _position = [position.coords.longitude, position.coords.latitude];
          geojson.geometry.coordinates.push(_position);
          map.getSource("route").setData(geojson);
        };

        const setCurrentPosition = (position) => {
          currentPositionMarker.setLngLat([
            position.coords.longitude,
            position.coords.latitude,
          ]);
        };
      });
      self.mapObject = map;
    },
    failurePosition: function (err) {
      alert("Error Code: " + err.code + " Error Message: " + err.message);
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
#map-cont {
  width: 100%;
  height: 500px;
}

#map {
  width: 100%;
  height: 100%;
}
</style>
